#include <p18f452.h>
#include <delays.h>
#include <stdio.h>
#include <usart.h>
#include <math.h>




#include "lcd.h"
#include "menu.h"
#include "StartUp.h"
#include "JoyStick.h"
#include "Propulsion.h"
#include "IO.h"
#include "I2C_Master.h"


char  liste[10][17] = { "initialisation", "vidage", "depose bleue", "depose blanche", 
						"depose rouge", "tir bleue", "tir blanche", "tir rouge", 
						"blocage", ""};
// commandes correspondant  la liste ci-dessus
char commandes[10] = {0xE0, 0xD2, 0x48, 0x2C, 0xA6, 0x7E, 0x98, 0x46, 0x32, 0 };

void main()
{
	int x=0;
	char ch=0;
	int Val1=0;
	int Val2=0;
	unsigned int cpt=0;
	char buf[20];
	
	int Value=0;
	
	int i=0;
	int ack=0;
	unsigned char Data[2]={0x00,30},DataReceive[10]={1,2,3,4};
	char ret;
	TGeom geom;
	char carac[4] = {'-', 0x5C, '|', '/'};
	Init_Peripheriques();						// Dmarre le robot et lance le CheckUp

	Check_Up();									// Scanne l'ensemble des priphriques et vrifie leur fonctionnement
	//Joy_Click();
	while (IO_Jack());
	

/*
// test
// rampe d'accelration 10->250		

	Commande_Rouleau_Droit( -50 );
	Commande_Rouleau_Gauche( 50 );

	for( i=10 ; i<250; i+=10 ){
		Commande_Propulsion( i, -i );
		Delay10KTCYx(50);
	}
	Commande_Propulsion( 0, 0 );

	Commande_Rouleau_Droit( 0 );
	Commande_Rouleau_Gauche( 0 );
*/

	
// test
// lecture de l'tat de la carte propulsion
	stdout = _H_USER;
	
	ret = Ping_Propulsion();
	if( ret==0 )
		printf("propulsion ok\n");
	else
		printf("propulsion pb !\n");
	
	printf("ready to go ?\n");
	while( !Joy_Sw() );
	Delay10KTCYx(200);
/*	
	ret = GotoPoint_Propulsion( 1000, 1000, 50 );
	if( ret==0 )
		printf("gotopoint ok\n");
	else
		printf("pb gotopoint : %d!\n", ret);
*/
	Delay10KTCYx(100);
//	while( !Joy_Sw() );
	
	//WriteUSART('I');
	i=0;
	while(1){
			/*	
			// si une donne est prsente sur la liaison srie
			if( DataRdyUSART() ){
				char c = ReadUSART();
				printf("%c", c);			// la lire
				//Delay10KTCYx(1);
				if(c=='\n') WriteUSART('I');

			}
			*/
			
		if( Joy_Sw() ){
			WriteUSART("\n");
			_ReadUSART(NULL);
			Delay10KTCYx(200);	
			ret = Ping_Propulsion();
			if( ret==0 )
				printf("propulsion ok\n");
			else
				printf("propulsion pb !\n");
			Delay10KTCYx(200);	
		}
		
		
		//LCD_GotoXY(0,0);
		
		ret = Etat_Propulsion( &geom );
		//printf("reponse (%d)\n", ret);
		printf("%c", carac[i%4]); i++;
		
		if(ret>=0)
			//printf( "%+05d %+05d %d\n", geom.X, geom.Y, (int) (10000*geom.psi)  );	
			printf( "%+05d %+05d\n", geom.X, geom.Y  );	
		else
			printf("pas de reponse (%d)\n", ret);
		
		Delay10KTCYx(200);	
		Delay10KTCYx(200);	
		
	}
	


// test
// envoi de commandes au barillet	
	stdout = _H_USER;
	while(1)
	{	
		ret = ChoisirDansListe( liste );
		
		LCD_Clear();
		Delay10KTCYx(200);

		if( ret>=0 ){
			ret = I2C_Send( 0x86, commandes[ret] );
			printf( "I2C_Send dit %d\n", ret );
			while( !Joy_Sw() );
		}
		Delay10KTCYx(200);
		
	}

}
