

#define 	ADR_I2C_EJECTEUR		0x52			// Adresse de la carte servo



#define 	CONS_NONE				0x00

#define 	BRASG_REPOS				0x25
#define 	BRASG_ACTIF				0x63

#define 	BRASD_REPOS				0xA0
#define 	BRASD_ACTIF				0xF5


/*	test des jecteurs	
	while(1){
		print_str("droit\n");
		Ejecteur_Droit_Actif();	
		Joy_Click();
		Ejecteur_Droit_Repos();	
		Joy_Click();
		
		print_str("gauche\n");
		Ejecteur_Gauche_Actif();	
		Joy_Click();
		Ejecteur_Gauche_Repos();	
		Joy_Click();
	}
*/



// --------------------------------------------------------------------------
/* met l'ejecteur de balles droit au repos(lev)
*/
int Ejecteur_Droit_Repos(void);


// --------------------------------------------------------------------------
/* met l'ejecteur de balles droit aaza	zerza	ctif(bess)
*/
int Ejecteur_Droit_Actif(void);


// --------------------------------------------------------------------------
/* met l'ejecteur de balles gauche au repos(lev)
*/
int Ejecteur_Gauche_Repos(void);


// --------------------------------------------------------------------------
/* met l'ejecteur de balles gauche actif(bess)
*/
int Ejecteur_Gauche_Actif(void);


