// Fichier Led.c
/////////////////////////////////////////////////////////

/********************************************************
 *                                                      *
 *                Code source de la librairie           *
 *					de la carte principale 				*
 *                                                      *
 * .Date de cration : 29/12/07                         *
 * .Auteur : Philippe Lucidarme                         *       
 *                                                      *
 * .Descriptions :                                      *
 *      - code des fonctions pour la carte principale   *
 *                                                      *
 *                                                      *
 *                                                      *
 * .Remarques :                                         *
 *                                                      *
 ********************************************************/

#include <p18f452.h>		// Librairie du PIC utilis

#include "led.h"




// --------------------------------------------------------------------------
/* Initialise le port de la led rouge en sortie
 *  Pas de paramtre
*/
void Led_Init (void)
{
	TRIS_LED_ROUGE=0;		// Configure le bit en sortie
}






// --------------------------------------------------------------------------
/* Commande la led rouge
 *  0 = Led teinte
 *  1 =Led allume
*/
void LedRouge (unsigned char Value)
{
	LED_ROUGE=!Value;		// Place l'inverse de la valeur sur le port (led active  l'tat bas)
}




