// Fichier Led.h
/////////////////////////////////////////////////////////

/********************************************************
 *                                                      *
 *                 Header de la librairie               *
 *					de la carte principale 				*
 *                                                      *
 * .Date de cration : 29/12/07                         *
 * .Auteur : Philippe Lucidarme                         *       
 *                                                      *
 * .Descriptions :                                      *
 *      - code des fonctions pour la carte principale   *
 *                                                      *
 * .Grandes modifications :                             *
 *  __________________________________________________  *
 * |   DATE   |   Auteur   |          Detail          | *
 * |--------------------------------------------------| *
 * | 28/12/07 | P.Lucidarme| Cration et code des     | *
 * |          |			   | fonctions: 			  | *
 * |          |            | - ConfigureProcesseur    | *
 * |          |            | - Joy_X                  | *
 * |          |            | - Joy_Y                  | * 
 * |          |            |                          | *  
 * |--------------------------------------------------| *
 * |          |            |                          | *
 * |--------------------------------------------------| *
 * |          |            |                          | *
 * |--------------------------------------------------| *
 * |__________|____________|__________________________| *
 *                                                      *
 *                                                      *
 * .Remarques :                                         *
 *                                                      *
 ********************************************************/


#define 	LED_ROUGE				PORTBbits.RB3			// Led active  l'tat bas
#define 	TRIS_LED_ROUGE			TRISBbits.TRISB3		// Led active  l'tat bas



// --------------------------------------------------------------------------
/* Initialise le port de la led rouge en sortie
 *  Pas de paramtre
*/
void Led_Init (void);




// --------------------------------------------------------------------------
/* Commande la led rouge
 *  0 = Led teinte
 *  1 =Led allume
*/
void LedRouge (unsigned char);





